/*       DECIDIR             Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <stdlib.h>

#include "global.hpp"

//#define       DEBUG


#define         V_MAX_DELANTE   10
#define         V_MAX_ATRAS     -10
#define         CAMPO_VISION    50
#define         FACTOR_LADOS    0.4
#define         FACTOR_CENTRO   0.3

void robot::decidir(void)
{
 float s1 , s2 , s3;

	s1 = ((int)ini_s->di_salida()[0] % (CAMPO_VISION + 1));
	s2 = ((int)ini_s->di_sig()->di_salida()[0] % (CAMPO_VISION + 1));
	s3 = ((int)ini_s->di_sig()->di_sig()->di_salida()[0] % (CAMPO_VISION + 1));
	v1 = V_MAX_DELANTE - (CAMPO_VISION - s3) * FACTOR_LADOS - (CAMPO_VISION - s2) * FACTOR_CENTRO;
	v2 = V_MAX_DELANTE - (CAMPO_VISION - s1) * FACTOR_LADOS - (CAMPO_VISION - s2) * FACTOR_CENTRO;
	if(abs((int)(s1 - s3)) < 4 && (s1 < (CAMPO_VISION * 0.7) || s2 < (CAMPO_VISION * 0.75)))
	{
		v1 = v1 + 3;
		v2 = v2 - 3;
	}
	if(v1 < V_MAX_ATRAS) v1 = V_MAX_ATRAS;
	if(v1 > V_MAX_DELANTE) v1 = V_MAX_DELANTE;
	if(v2 < V_MAX_ATRAS) v2 = V_MAX_ATRAS;
	if(v2 > V_MAX_DELANTE) v2 = V_MAX_DELANTE;
	sprintf(msg_sale , "RCV%f %f" , v1 , v2);
	enviar_msg(sock);
#ifdef DEBUG
	printf("El robot '%s' cambia la velocidad a v1 = %d v2 = %d\n" , nombre , (int)v1 , (int)v2);
	if(fichero == CIERTO) fprintf(accion,"El robot '%s' cambia la velocidad a v1 = %d v2 = %d\n" , nombre , (int)v1 , (int)v2);
#endif
}
