OBJ_MUNDO_XLIB= ../mundo/mundo.o ../mundo/figura.o ../mundo/mapa.o ../mundo/monitor.o ../mundo/robot.o ../mundo/sensor.o ../mundo/ven-xlib.o ../mundo/socket.o
OBJ_MUNDO_XT= ../mundo/mundo.o ../mundo/figura.o ../mundo/mapa.o ../mundo/monitor.o ../mundo/robot.o ../mundo/sensor.o ../mundo/ven-xt.o ../mundo/socket.o
DEFS_MUNDO= ../mundo/global.hpp ../mundo/coord.hpp ../mundo/figura.hpp ../mundo/mapa.hpp ../mundo/robot.hpp ../mundo/monitor.hpp ../mundo/sensor.hpp ../mundo/ventana.hpp ../mundo/socket.hpp

MUNDO_XLIB: $(OBJ_MUNDO_XLIB)
	$(CC) $(OBJ_MUNDO_XLIB) -o $(MUNDO_EXE_XLIB) $(LIBS_XLIB)
	chmod 755 $(MUNDO_EXE_XLIB)

MUNDO_XT: $(OBJ_MUNDO_XT)
	$(CC) $(OBJ_MUNDO_XT) -o $(MUNDO_EXE_XT) $(LIBS_XT)
	chmod 755 $(MUNDO_EXE_XT)

../mundo/mundo.o: ../mundo/mundo.C $(DEFS)
	$(CC) -c ../mundo/mundo.C $(INCLUDES) -o ../mundo/mundo.o

../mundo/figura.o: ../mundo/figura.C $(DEFS)
	$(CC) -c ../mundo/figura.C $(INCLUDES) -o ../mundo/figura.o

../mundo/mapa.o: ../mundo/mapa.C $(DEFS)
	$(CC) -c ../mundo/mapa.C $(INCLUDES) -o ../mundo/mapa.o

../mundo/monitor.o: ../mundo/monitor.C $(DEFS)
	$(CC) -c ../mundo/monitor.C $(INCLUDES) -o ../mundo/monitor.o

../mundo/robot.o: ../mundo/robot.C $(DEFS)
	$(CC) -c ../mundo/robot.C $(INCLUDES) -o ../mundo/robot.o

../mundo/sensor.o: ../mundo/sensor.C $(DEFS)
	$(CC) -c ../mundo/sensor.C $(INCLUDES) -o ../mundo/sensor.o

../mundo/ven-xlib.o: ../mundo/ven-xlib.C $(DEFS)
	$(CC) -c ../mundo/ven-xlib.C $(INCLUDES) -o ../mundo/ven-xlib.o

../mundo/ven-xt.o: ../mundo/ven-xt.C $(DEFS)
	$(CC) -c ../mundo/ven-xt.C $(INCLUDES) -o ../mundo/ven-xt.o

../mundo/socket.o: ../mundo/socket.C $(DEFS)
	$(CC) -c ../mundo/socket.C $(INCLUDES) -o ../mundo/socket.o


